# LinuxVMDeploy (1.0.0)

This step can be used to upload files to and run a command on a set of Linux virtual machines. FileSpec, BuildInfo and ReleaseBundle inputs are supported (exactly one of these), and everything in those resources will be uploaded.
Commands can be supplied to run after the upload (deployCommand) after deployCommand (postDeployCommand) and in the event of rollBack (onRollback).

### YML

```
- name: myLinuxVMDeployStep
  type: LinuxVMDeploy
  configuration:
    environmentVariables:
      dry_run:                 <String> # If true, user-defined commands will not run.
    targetDirectory:           <String> # Path of the directory where the deploy artifacts will be uploaded. The directory will be created if it does not exist. Default "<sshUser's $HOME>/$step_name/$run_id".
    rolloutDelaySecs:          <Int> # Time in seconds to wait between deploys.
    fastFail:                  <Boolean> # If true, the step will not deploy to additional VMs after the first failure. Default true.
    sshUser:                   <String> # The ssh user used to connect to target VMs.
    vmEnvironmentVariables:    <String[]> # Environment variables to set on target VMs. They will be in the environment for deployCommand and postDeployCommand. 
      - "foo=bar"
      - "baz=${step_name}"     # Step env vars can be passed to the vm.
    integrations:
      - name:                  <Artifactory integration> # Required if using ReleaseBundle inputResource.
    inputResources: 
      - name:                  <VMCluster resource> # Required
      - name:                  <BuildInfo resource |FileSpec resource|ReleaseBundle resource> # Exactly one inputResource is required.
  scripts:
    - name:                  <String>
      context:               <"buildNode"|"targetCluster"|"currentCluster"> # Where the script should be run. "currentCluster" is only supported for blueGreen strategy.
      commands:              <String[]> # Shell commands to run on the specified context.
```
